<script setup lang="ts">
import VoteBox from '@/components/VoteBox.vue'
import API from '@/scripts/api'
import { encryptBallot } from '@/scripts/crypto'
import { useAppStore } from '@/store/app'
import { useDataStore } from '@/store/data'
import { computed, onMounted, reactive } from 'vue'
import { useRoute, useRouter } from 'vue-router'

const route = useRoute()
const router = useRouter()
const data = useDataStore()
const app = useAppStore()

const state = reactive({
  voteId: null as number | null,
  loading: false,
  answers: [] as {arr: boolean[], count: number}[]
})

const vote = computed(() => {
  return data.votes.find(v => v.id === state.voteId)
})

onMounted(() => {
  state.voteId = parseInt(route.params.id as string)
  state.answers = []
  data.refreshVotes().then(async () => {
    if (state.voteId == null) return
    vote.value?.questions.forEach(q => {
      const arr: boolean[] = []
      q.options.forEach(() => arr.push(false))
      state.answers.push({ arr, count: 0 })
    })
  })
  app.clearNewOpenVoteNotif()
})

function toggleAnswer(questionIndex: number, optionIndex: number) {
  state.answers[questionIndex].arr[optionIndex] = !state.answers[questionIndex].arr[optionIndex]
  state.answers[questionIndex].count = state.answers[questionIndex].arr.filter(b => b).length
}

const sendDisabled = computed(() => {
  if (vote.value == null) return true
  for (const [i, q] of vote.value.questions.entries()) {
    const a = state.answers[i]
    if (a == null) return true
    if (a.count > q.max) return true
    if (a.count < q.min) return true
  }
  return false
})

function send() {
  if (vote.value == null) return
  state.loading = true

  const { encryptedBallot, clearBallot } = encryptBallot(state.answers.map(a => a.arr), vote.value)
  const voteId = vote.value.id
  API.castBallot(voteId, encryptedBallot.encrypted_ballot, encryptedBallot.encrypted_telling_token).then(() => {
    app.notification('success', 'Bulletin de vote envoyé !')
    data.saveBallot(voteId, clearBallot)
    router.push('/votes')
  }).finally(() => {
    state.loading = false
  })
}
</script>

<template>
  <div>
    <div v-if="vote != null && vote.status === 'open'" class="flex flex-col px-3 max-w-2xl mx-auto">
      <h1 class="text-2xl">Vote en cours #{{vote.id}}</h1>

      <vote-box :vote="vote" class="mt-2 mb-6" mode="info" />

      <div v-if="state.answers.length > 0">
        <div v-for="question, questionIndex in vote.questions" v-bind:key="question.question" class="mb-3">
          <h2 class="text-xl">Q: {{question.question}}</h2>
          <div>
            <v-sheet rounded class="my-2 linear duration-200 cursor-pointer" :color="state.answers[questionIndex].arr[optionIndex] ? 'green-lighten-4' : ''"
              v-for="option, optionIndex in question.options" v-bind:key="option"
              @click="toggleAnswer(questionIndex, optionIndex)" >
              <div class="flex items-center">
                <v-checkbox-btn hide-details v-model="state.answers[questionIndex].arr[optionIndex]"/>
                <p class="text-lg">{{ option }}</p>
              </div>
            </v-sheet>
          </div>
          <v-alert v-if="state.answers[questionIndex].count > question.max"
            color="warning" density="compact"
            :text="`Vous devez choisir au plus ${question.max} option${question.max === 1 ? '' : 's'}`"/>
          <v-alert v-if="state.answers[questionIndex].count < question.min && question.min > 1"
            color="warning" density="compact" variant="tonal"
            :text="`Vous devez choisir au moins ${question.min} option${question.min === 1 ? '' : 's'}`"/>
        </div>
      </div>

      <div class="my-5 flex">
        <v-btn @click="$router.back">Retour</v-btn>
        <v-btn color="primary" class="ml-3 grow" :disabled="sendDisabled" :loading="state.loading" @click="send">Envoyer</v-btn>
      </div>
    </div>

    <div v-else-if="vote?.status === 'closed'" class="flex justify-center">
      <div class="max-w-md">
        <v-alert class="mb-5" title="Le vote est fermé">
          Les résultats sont en cours de calcul, attendez quelques secondes ;)
        </v-alert>
        <v-btn class="mb-5" disabled color="success" link block :to="`/votes/${vote.id}/results`">Calcul des résultats...</v-btn>
        <v-btn link block to="/votes">Retour à la liste des votes</v-btn>
      </div>
    </div>

    <div v-else-if="vote?.status === 'validated'" class="flex justify-center p-5">
      <div class="max-w-md">
        <v-alert class="mb-5" title="Le vote est fermé" text="mais les résultats sont disponibles !"/>
        <v-btn class="mb-5" color="success" link block :to="`/votes/${vote.id}/results`">Voir les résultats</v-btn>
        <v-btn link block to="/votes">Liste des votes</v-btn>
      </div>
    </div>
  </div>
</template>
